

<?php

require 'config.php';
require 'Slim/Slim.php';
// Allow from any origin
if (isset($_SERVER['HTTP_ORIGIN'])) {
    header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
    header('Access-Control-Allow-Credentials: true');
    header('Access-Control-Max-Age: 86400');    // cache for 1 day
}

// Access-Control headers are received during OPTIONS requests
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
        header("Access-Control-Allow-Methods: GET, POST, OPTIONS");

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
        header("Access-Control-Allow-Headers: {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

    exit(0);
}

\Slim\Slim::registerAutoloader();
$app = new \Slim\Slim();
//===================  API yang aktif ======================
$app->get('/index', 'index');
$app->post('/login', 'login'); /* User login */
$app->post('/signup', 'signup'); /* User Signup  */
$app->post('/getUser', 'getUser'); /* User login */
$app->post('/getVersion', 'getVersion'); 
$app->post('/updateUser', 'updateUser');
$app->post('/getProductLaris', 'getProductLaris');
$app->post('/verifikasiPIN', 'verifikasiPIN');
$app->post('/DashGetSaloKasAwal', 'DashGetSaloKasAwal'); 
$app->post('/getPOSInfo', 'getPOSInfo'); 
$app->post('/getManagementKas', 'getManagementKas'); 
//=================== API yang aktif ======================
$app->post('/customer', 'customer'); 
$app->post('/getSubCategory', 'getSubCategory');
$app->post('/productCategory', 'productCategory'); 
$app->post('/getProductPOS', 'getProductPOS');  
$app->post('/getProductRO', 'getProductRO');  
$app->post('/getCategoryPOS', 'getCategoryPOS');  //getCategoryPOS
$app->post('/product', 'product'); 
$app->post('/stockNonProduct', 'stockNonProduct'); 
$app->post('/stockNonProductHdr', 'stockNonProductHdr'); 
$app->post('/stockPackaging', 'stockPackaging');  
$app->post('/ProductForRO', 'ProductForRO'); 
$app->post('/stockProduct', 'stockProduct'); 
$app->post('/stockProductHdr', 'stockProductHdr'); 
$app->post('/stockProductAvailable', 'stockProductAvailable');
$app->post('/allproduct', 'allproduct'); 
$app->post('/getProductSample', 'getProductSample'); 
$app->post('/getPromo', 'getPromo');  
$app->post('/getPromoauto', 'getPromoauto');  
$app->post('/getPromoautoByID', 'getPromoautoByID');  
$app->post('/getBank', 'getBank'); 
$app->post('/getTransID', 'getTransID'); 
$app->post('/getTransDetail', 'getTransDetail'); 
$app->post('/getTotalPendapatan', 'getTotalPendapatan');
$app->post('/getCategoryPenjualan', 'getCategoryPenjualan');
$app->post('/getTotalItemPenjualan', 'getTotalItemPenjualan');
$app->post('/getTotalDiskonPenjualan', 'getTotalDiskonPenjualan');
$app->post('/getItemPenjualanByUser', 'getItemPenjualanByUser');
$app->post('/getItemPenjualan', 'getItemPenjualan');
$app->post('/getTotalPenjualan', 'getTotalPenjualan');
$app->post('/getTotalPenjualanByPayment', 'getTotalPenjualanByPayment');
$app->post('/getTotalCashier', 'getTotalCashier');
$app->post('/getTotalPayment', 'getTotalPayment');
$app->post('/getTotalVoid', 'getTotalVoid');
$app->post('/getTotalBill', 'getTotalBill');
$app->post('/getSaldoSummary', 'getSaldoSummary');
$app->post('/postVoid', 'postVoid');
$app->post('/postRefund', 'postRefund');
$app->post('/getEmailSubcribe', 'getEmailSubcribe');
// ================ CRUD CART START ===============
$app->post('/getVoucher', 'getVoucher');
$app->post('/getCart', 'getCart');
$app->post('/getPenjualanHdr', 'getPenjualanHdr');
$app->post('/getPenjualanDtl', 'getPenjualanDtl');
$app->post('/getSummary', 'getSummary');
$app->post('/getSummaryPenjualan', 'getSummaryPenjualan');
$app->post('/getSalesSummary', 'getSalesSummary');
$app->post('/getSalesSummaryByUser', 'getSalesSummaryByUser');
$app->post('/updateCart', 'updateCart');
$app->post('/updateCartBTB', 'updateCartBTB');
$app->post('/deleteAllCart', 'deleteAllCart');
$app->post('/deletePageCart', 'deletePageCart');
$app->post('/deleteCart', 'deleteCart'); 
$app->post('/insertCart', 'insertCart'); /* Menambahkan data kedalam keranjang */
$app->post('/insertCartBTB', 'insertCartBTB'); /* Menambahkan data kedalam keranjang */
$app->post('/insertCartBPG', 'insertCartBPG');
$app->post('/insertCartBPB', 'insertCartBPB');
$app->post('/insertPenjualan', 'insertPenjualan'); /* Insert Data ke dalam table penjualan detail */
$app->post('/insertPenjualanHdr', 'insertPenjualanHdr'); /* Insert Data ke dalam table penjualan header */
$app->post('/insertPenjualanDtl', 'insertPenjualanDtl'); /* Insert Data ke dalam table penjualan detail */
$app->post('/insertPenjualanHdrSyn', 'insertPenjualanHdrSyn'); /* Insert Data ke dalam table penjualan header */
$app->post('/insertPenjualanDtlSyn', 'insertPenjualanDtlSyn'); /* Insert Data ke dalam table penjualan detail */
$app->post('/insertPenjualanHdrSynV1', 'insertPenjualanHdrSynV1'); /* Insert Data ke dalam table penjualan header */
$app->post('/insertPenjualanDtlSynV1', 'insertPenjualanDtlSynV1'); /* Insert Data ke dalam table penjualan detail */
$app->post('/insertPaymentSyn', 'insertPaymentSyn'); /* Insert Data ke dalam table penjualan detail */
$app->post('/updateCustomer', 'updateCustomer');
$app->post('/updatePromo', 'updatePromo'); 
// ================ CRUD CART END =================

// ================ GET ID ========================
$app->post('/getROID', 'getROID');
$app->get('/SendSMS', 'SendSMS');
// ================ GET ID END ====================

// ================ CRUD RO START =================
$app->post('/postWO', 'postWO');
$app->post('/insertHdrRO', 'insertHdrRO'); 
$app->post('/insertDtlRO', 'insertDtlRO');
$app->post('/deleteRO', 'deleteRO'); 
$app->post('/getRO', 'getRO');
$app->post('/getRODetail', 'getRODetail');
$app->post('/getROBTB', 'getROBTB');
$app->post('/getROBTBDetail', 'getROBTBDetail');
$app->post('/getTransaksiROHdr', 'getTransaksiROHdr');
$app->post('/getTransaksiROHdrFilter', 'getTransaksiROHdrFilter');
$app->post('/getRODtl','getRODtl');
$app->post('/deleteRODtl','deleteRODtl');
$app->post('/editRODtl','editRODtl');
$app->post('/insertBTB', 'insertBTB'); /* Insert Data ke dalam table penjualan */
$app->post('/insertBPG', 'insertBPG'); /* Insert Data ke dalam table penjualan */
$app->post('/insertBPB', 'insertBPB'); /* Insert Data ke dalam table penjualan */
// ================ CRUD RO START =================

$app->post('/sub_category', 'sub_category');
$app->post('/PosGetSaloKasAkhir', 'PosGetSaloKasAkhir'); 
$app->post('/registrasikas', 'registrasikas'); /* Registrasi Kas */
$app->post('/pemindahankas', 'pemindahankas'); /* Registrasi Kas */
$app->post('/closingkas', 'closingkas');
$app->post('/feed', 'feed'); /* User Feeds  */
$app->post('/feedUpdate', 'feedUpdate'); /* User Feeds  */
$app->post('/feedDelete', 'feedDelete'); /* User Feeds  */
$app->post('/getImages', 'getImages');
$app->post('/getTransaksiBPGHdr', 'getTransaksiBPGHdr'); /* User Feeds  */
$app->post('/getTransaksiBPG', 'getTransaksiBPG'); 
$app->post('/getTransaksiKas', 'getTransaksiKas'); 
$app->post('/filterTransaksiKas', 'filterTransaksiKas');

// ====================== REPORT ===========================
$app->post('/getRptSaldo', 'getRptSaldo');
$app->post('/getRptPenjualan', 'getRptPenjualan');
$app->post('/getRptStockPenjualan', 'getRptStockPenjualan');
$app->post('/getRptPaymentPenjualan', 'getRptPaymentPenjualan');
$app->post('/getTransaksiPenjualanSyncron', 'getTransaksiPenjualanSyncron');
$app->post('/getTransaksiPenjualanHdr', 'getTransaksiPenjualanHdr');
$app->post('/getTransaksiPenjualanHdrFilter', 'getTransaksiPenjualanHdrFilter');
$app->post('/getTransaksiPenjualanHdrV1', 'getTransaksiPenjualanHdrV1');
$app->post('/getTransaksiPenjualanHdrFilterV1', 'getTransaksiPenjualanHdrFilterV1');
$app->post('/getTransaksiPenjualanDtl', 'getTransaksiPenjualanDtl');
$app->post('/getTransaksiPenjualanDtlV1', 'getTransaksiPenjualanDtlV1');
$app->post('/getTransaksiRefundDtl', 'getTransaksiRefundDtl');
$app->post('/getTransaksiRefundDtlFilter', 'getTransaksiRefundDtlFilter');
$app->post('/getTransaksiVoid', 'getTransaksiVoid');
$app->post('/getTransaksiVoidFilter', 'getTransaksiVoidFilter');
$app->post('/getTransaksiPromo', 'getTransaksiPromo');
$app->post('/getTransaksiPromoFilter', 'getTransaksiPromoFilter');
$app->post('/getRptBPG', 'getRptBPG');
$app->post('/getRptBPBHdr', 'getRptBPBHdr');
$app->post('/getRptBPB', 'getRptBPB');

// ======================== API FOR CHART START ============================
$app->get('/getChartItem/', 'getChartItem');
$app->get('/getChartSales/', 'getChartSales');
$app->get('/getChartPayment/', 'getChartPayment');
$app->get('/getChartCashier/', 'getChartCashier');
$app->get('/getChartDiscount/', 'getChartDiscount');
$app->post('/getChartDiscountFilter/', 'getChartDiscountFilter');

// ======================== API FOR CHART END ==============================
 
$app->run();

function index(){
    echo "Welcome to api development";
}
/* * *********************** USER LOGIN ************************************ */
/* ### User login ### */

function login() {

    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());

    try {

        $db = getDB();
        $userData = '';
        $sql = "SELECT * FROM vwMstUser WHERE (username=:username or email=:username2) and password=:password ";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("username", $data->username, PDO::PARAM_STR);
        $stmt->bindParam("username2", $data->username, PDO::PARAM_STR);
        $password = hash('sha256', $data->password);
        $stmt->bindParam("password", $password, PDO::PARAM_STR);
        $stmt->execute();
        $mainCount = $stmt->rowCount();
        $userData = $stmt->fetch(PDO::FETCH_OBJ);

        if (!empty($userData)) {
            $username = $userData->username;
            $userData->token = apiToken($username);
        }

        $db = null;
        if ($userData) {
            $userData = json_encode($userData);
            echo '{"userData": ' . $userData . '}';
        } else {
            echo '{"error":{"text":"Bad request wrong username and password"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getUser(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());

    try {

        $db = getDB();
        $userData = '';
        $sql = "SELECT * FROM vwMstUser";
        $stmt = $db->prepare($sql);
        $stmt->execute();
        $mainCount = $stmt->rowCount();
        $userData = $stmt->fetch(PDO::FETCH_OBJ);

        if (!empty($userData)) {
            $username = $userData->username;
            $userData->token = apiToken($username);
        }

        $db = null;
        if ($userData) {
            $userData = json_encode($userData);
            echo '{"getDataUser": ' . $userData . '}';
        } else {
            echo '{"error":{"text":"Bad request wrong username and password"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getVersion(){
    try {

        $db = getDB();
        $userData = '';
        $sql = "SELECT TOP 1 VersionCode as versionCode FROM tblMstVersion Order By UpdateDate DESC";
        $stmt = $db->prepare($sql);
        $stmt->execute();
        $appVer = $stmt->fetch(PDO::FETCH_OBJ);
        $db = null;
        if ($appVer) {
            $appVer = json_encode($appVer);
            echo $appVer;
        } else {
            echo '{"error":{"text":"Bad request wrong username and password"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getProductLaris() {
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "select TOP 10 ItemID, ItemName, UOMName, SUM(Qnty) as Qnty from vwPenjualan where MONTH(TransDate) =  datepart(mm,getdate()) group by ItemID, UOMName, ItemName order by SUM(Qnty) desc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getPOSInfo(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $lastCreated = $data->lastCreated;
    $WHSID = $data->WHSID;
    try {

        $db = getDB();
        $userData = '';
        $sql = "SELECT * FROM vwPOSInfo Where tanggal =:lastCreated and OutletId=:WHSID";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("lastCreated", $lastCreated, PDO::PARAM_STR);
        $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);
        $stmt->execute();
        $posInfo = $stmt->fetch(PDO::FETCH_OBJ);
        $db = null;
        if ($posInfo) {
            $posInfo = json_encode($posInfo);
             echo '{"userInfo": ' . $posInfo . '}';
        } else {
            echo '{"error":{"text":"Bad request wrong username and password"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ### User registration ### */

function signup() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $email = $data->email;
    $name = $data->name;
    $username = $data->username;
    $password = $data->password;
    $id_jabatan = $data->id_jabatan;
    $nomor_ponsel = $data->nomor_ponsel;

    try {

        $username_check = preg_match('~^[A-Za-z0-9_]{3,20}$~i', $username);
        $email_check = preg_match('~^[a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.([a-zA-Z]{2,4})$~i', $email);
        $password_check = preg_match('~^[A-Za-z0-9!@#$%^&*()_]{6,20}$~i', $password);

        echo $email_check . '<br/>' . $email;

        if (strlen(trim($username)) > 0 && strlen(trim($password)) > 0 && strlen(trim($email)) > 0 && $email_check > 0 && $username_check > 0 && $password_check > 0) {
            echo 'here';
            $db = getDB();
            $userData = '';
            $sql = "SELECT user_id FROM tblMstUser WHERE UserName=:username or Email=:email";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("email", $email, PDO::PARAM_STR);
            $stmt->execute();
            $mainCount = $stmt->rowCount();
            $created = time();
            if ($mainCount == 0) {

                /* Inserting user values */
                $sql1 = "INSERT INTO tblMstUser (UserName,Password,Email,Name, NomorPonsel, IdJabatan)VALUES(:username,:password,:email,:name, :nomor_ponsel, :id_jabatan)";
                $stmt1 = $db->prepare($sql1);
                $stmt1->bindParam("username", $username, PDO::PARAM_STR);
                $password = hash('sha256', $data->password);
                $stmt1->bindParam("password", $password, PDO::PARAM_STR);
                $stmt1->bindParam("email", $email, PDO::PARAM_STR);
                $stmt1->bindParam("name", $name, PDO::PARAM_STR);
                $stmt1->bindParam("nomor_ponsel", $nomor_ponsel, PDO::PARAM_STR);
                $stmt1->bindParam("id_jabatan", $id_jabatan, PDO::PARAM_STR);
                $stmt1->execute();

                $userData = internalUserDetails($email);
            }

            $db = null;


            if ($userData) {
                $userData = json_encode($userData);
                echo '{"userData": ' . $userData . '}';
            } else {
                echo '{"error":{"text":"Enter valid data"}}';
            }
        } else {
            echo '{"error":{"text":"Enter valid data"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updateUser(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $email = $data->email;
    $name = $data->name;
    $password = $data->password;
    $nomor_ponsel = $data->nomor_ponsel;

      /* Inserting user values */
        $db = getDB();
        $userData = '';
    $sql1 = "UPDATE tblMstUser SET Password=:password, Email=:email, NomorPonsel=:nomor_ponsel where UserId=:user_id";
    $stmt1 = $db->prepare($sql1);
    $stmt1->bindParam("user_id", $user_id, PDO::PARAM_STR);
    $password = hash('sha256', $data->password);
    $stmt1->bindParam("password", $password, PDO::PARAM_STR);
    $stmt1->bindParam("email", $email, PDO::PARAM_STR);
    $stmt1->bindParam("nomor_ponsel", $nomor_ponsel, PDO::PARAM_STR);
    $stmt1->execute();

    $sql = "SELECT * FROM vwMstUser WHERE (Username=:username or Email=:email) ";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("username", $data->username, PDO::PARAM_STR);
        $stmt->bindParam("email", $data->email, PDO::PARAM_STR);
        $stmt->execute();
        $userData = $stmt->fetch(PDO::FETCH_OBJ);
    if ($userData) {
        $userData = json_encode($userData);
        echo '{"userData": ' . $userData . '}';
    } else {
        echo '{"error":{"text":"Enter valid data"}}';
    }
}

function email() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $email = $data->email;

    try {

        $email_check = preg_match('~^[a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.([a-zA-Z]{2,4})$~i', $email);

        if (strlen(trim($email)) > 0 && $email_check > 0) {
            $db = getDB();
            $userData = '';
            $sql = "SELECT username FROM emailUsers WHERE email=:email";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("email", $email, PDO::PARAM_STR);
            $stmt->execute();
            $mainCount = $stmt->rowCount();
            $created = time();
            if ($mainCount == 0) {

                /* Inserting user values */
                $sql1 = "INSERT INTO emailUsers(email)VALUES(:email)";
                $stmt1 = $db->prepare($sql1);
                $stmt1->bindParam("email", $email, PDO::PARAM_STR);
                $stmt1->execute();
            }
            $userData = internalEmailDetails($email);
            $db = null;
            if ($userData) {
                $userData = json_encode($userData);
                echo '{"userData": ' . $userData . '}';
            } else {
                echo '{"error":{"text":"Enter valid dataaaa"}}';
            }
        } else {
            echo '{"error":{"text":"Enter valid data"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ### internal Username Details ### */

function internalUserDetails($input) {

    try {
        $db = getDB();
        $sql = "SELECT user_id, name, email, username FROM tblMstUser WHERE username=:input or email=:input2";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("input", $input, PDO::PARAM_STR);
        $stmt->bindParam("input2", $input, PDO::PARAM_STR);
        $stmt->execute();
        $usernameDetails = $stmt->fetch(PDO::FETCH_OBJ);
        $usernameDetails->token = apiToken($usernameDetails->username);
        $db = null;
        return $usernameDetails;
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ######## Buat registrasi kas ############### */
function getManagementKas() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $WHSID = $data->WHSID;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select *, (select SUM(TotalKas) from tblTransaksiKasHdr where TypeKas = 'KT') as CI , (select SUM(TotalKas) from tblTransaksiKasHdr where TypeKas = 'KK') as CO,  (select SUM(TotalKas) from tblTransaksiKasHdr where TypeKas = 'KT') - (select SUM(TotalKas) from tblTransaksiKasHdr where TypeKas = 'KK') as Saldo from tblTransaksiKasHdr where OutletId =:WHSID AND TypeKas IN ('KT', 'KK') and MONTH(Tanggal)=MONTH(GetDate()) and YEAR(Tanggal)=YEAR(GetDate()) order by Tanggal desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"kasData": ' . json_encode($feedData) . '}';
            else
                echo '{"kasData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function registrasikas(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $tanggal = $data->tanggal;
    $user_id = $data->user_id;
    $username = $data->username;
    $kas_awal = $data->kas_awal;
    $buka = $data->buka;
    $kas_akhir = $data->kas_akhir;
    $tutup = $data->tutup;
    $token = $data->token;
    $catatan = $data->catatan;
    $seratus = $data->seratus;
    $limapuluh = $data->limapuluh;
    $duapuluh = $data->duapuluh;
    $sepuluh = $data->sepuluh;
    $limaribu = $data->limaribu;
    $duaribu = $data->duaribu;
    $seribu = $data->seribu;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSRegisterKasSave @tanggal=:tanggal, @username=:username, @kas_awal=:kas_awal, @buka=:buka, @kas_akhir=:kas_akhir, @tutup=:tutup, @catatan=:catatan, @seratus=:seratus, @limapuluh=:limapuluh, @duapuluh=:duapuluh, @sepuluh=:sepuluh, @limaribu=:limaribu, @duaribu=:duaribu, @seribu=:seribu,  @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('tanggal', $tanggal, PDO::PARAM_STR);
            $stmt->bindParam('username', $username, PDO::PARAM_STR);
            $stmt->bindParam('kas_awal', $kas_awal, PDO::PARAM_STR);
            $stmt->bindParam('buka', $buka, PDO::PARAM_STR);
            $stmt->bindParam('kas_akhir', $kas_akhir, PDO::PARAM_STR);
            $stmt->bindParam('tutup', $tutup, PDO::PARAM_STR);
            $stmt->bindParam('catatan', $catatan, PDO::PARAM_STR);
            $stmt->bindParam('seratus', $seratus, PDO::PARAM_STR);
            $stmt->bindParam('limapuluh', $limapuluh, PDO::PARAM_STR);
            $stmt->bindParam('duapuluh', $duapuluh, PDO::PARAM_STR);
            $stmt->bindParam('sepuluh', $sepuluh, PDO::PARAM_STR);
            $stmt->bindParam('limaribu', $limaribu, PDO::PARAM_STR);
            $stmt->bindParam('duaribu', $duaribu, PDO::PARAM_STR);
            $stmt->bindParam('seribu', $seribu, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $sql1 = "SELECT TOP(1) * FROM tblTransaksiSaldoHdr WHERE Username=:username1 AND Tanggal=:tanggal1 ORDER BY Tanggal";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam("username1", $username, PDO::PARAM_INT);
            $stmt->bindParam("tanggal1", $tanggal, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"registerData": ' . json_encode($feedData) . '}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function pemindahankas(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $pemberi = $data->pemberi;
    $type_kas = $data->type_kas;
    $penerima = $data->penerima;
    $total_kas = $data->total_kas;
    $token = $data->token;
    $catatan = $data->catatan;
    $seratus = $data->seratus;
    $limapuluh = $data->limapuluh;
    $duapuluh = $data->duapuluh;
    $sepuluh = $data->sepuluh;
    $limaribu = $data->limaribu;
    $duaribu = $data->duaribu;
    $seribu = $data->seribu;
    $flag = 0;

    $systemToken = apiToken($pemberi);

    try {

        if ($systemToken == $token) {
            $db = getDB();
            $sql = "Exec spPOSPemindahanKasSave @type_kas=:type_kas, @pemberi=:pemberi, @penerima=:penerima, @total_kas=:total_kas, @catatan=:catatan, @seratus=:seratus, @limapuluh=:limapuluh, @duapuluh=:duapuluh, @sepuluh=:sepuluh, @limaribu=:limaribu, @duaribu=:duaribu, @seribu=:seribu,  @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('type_kas', $type_kas, PDO::PARAM_STR);
            $stmt->bindParam('pemberi', $pemberi, PDO::PARAM_STR);
            $stmt->bindParam('penerima', $penerima, PDO::PARAM_STR);
            $stmt->bindParam('total_kas', $total_kas, PDO::PARAM_STR);
            $stmt->bindParam('catatan', $catatan, PDO::PARAM_STR);
            $stmt->bindParam('seratus', $seratus, PDO::PARAM_STR);
            $stmt->bindParam('limapuluh', $limapuluh, PDO::PARAM_STR);
            $stmt->bindParam('duapuluh', $duapuluh, PDO::PARAM_STR);
            $stmt->bindParam('sepuluh', $sepuluh, PDO::PARAM_STR);
            $stmt->bindParam('limaribu', $limaribu, PDO::PARAM_STR);
            $stmt->bindParam('duaribu', $duaribu, PDO::PARAM_STR);
            $stmt->bindParam('seribu', $seribu, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $sql1 = "SELECT * FROM pos_tbl_transaksi_kas ORDER BY tanggal";
            $stmt = $db->prepare($sql1);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"kasData": ' . json_encode($feedData) . '}';
            else
                echo '{"kasData": ""}';
        }else {
            echo '{"error":{"text":"Enter valid data"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function closingkas(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $created_by = $data->created_by;
    $dari = $data->dari;
    $sampai = $data->sampai;
    $type_kas = 'PK';
    $pemberi = $data->kasir;
    $cash   = $data->cash;
    $BNI  = $data->BNI;
    $BCA = $data->BCA;
    $OVO = $data->OVO;
    $penerima = $data->penerima;
    $total_kas = $cash+$BNI+$BCA+$OVO;
    $token = $data->token;
    $catatan = $data->catatan;
    date_default_timezone_set("Asia/Bangkok");
    $created_date =  date("Y-m-d h:i:s");

    $systemToken = apiToken($created_by);

    try {
            $db = getDB();
            $sql = "INSERT INTO pos_tbl_transaksi_kas (tanggal,tanggal_sampai,type_kas,pemberi,cash,BNI,BCA,OVO,total_kas,penerima,catatan,created_by,created_date,updated_by,updated_date) VALUES (:dari,:sampai,:type_kas,:pemberi,:cash,:BNI,:BCA,:OVO,:total_kas,:penerima,:catatan,:created_by,:created_date,:created_by2,:created_date2)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('type_kas', $type_kas, PDO::PARAM_STR);
            $stmt->bindParam('pemberi', $pemberi, PDO::PARAM_STR);
            $stmt->bindParam('cash', $cash, PDO::PARAM_STR);
            $stmt->bindParam('BNI', $BNI, PDO::PARAM_STR);
            $stmt->bindParam('BCA', $BCA, PDO::PARAM_STR);
            $stmt->bindParam('OVO', $OVO, PDO::PARAM_STR);
            $stmt->bindParam('penerima', $penerima, PDO::PARAM_STR);
            $stmt->bindParam('total_kas', $total_kas, PDO::PARAM_STR);
            $stmt->bindParam('catatan', $catatan, PDO::PARAM_STR);
            $stmt->bindParam('created_by', $created_by, PDO::PARAM_STR);
            $stmt->bindParam('created_date', $created_date, PDO::PARAM_STR);
            $stmt->bindParam('created_by2', $created_by, PDO::PARAM_STR);
            $stmt->bindParam('created_date2', $created_date, PDO::PARAM_STR);
            $stmt->execute();

            $sql2 = "UPDATE pos_tbl_trn_penjualan_header set Status = '2' where TransDate BETWEEN :dari2 and :sampai2";
            $stmt2 = $db->prepare($sql2);
            $stmt2->bindParam('dari2', $dari, PDO::PARAM_STR);
            $stmt2->bindParam('sampai2', $sampai, PDO::PARAM_STR);
            $stmt2->execute();
            
            $sql1 = "SELECT * FROM pos_tbl_transaksi_kas ORDER BY tanggal";
            $stmt = $db->prepare($sql1);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"kasData": ' . json_encode($feedData) . '}';
            else
                echo '{"error":{"text":"Enter valid data"}}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ########  Get Total Penjualan ########*/
function getTotalPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;

    try {
            $feedData = '';
            $db = getDB();
            
            $sql = "Select ISNULL(SUM(GrandTotal),0) as Total from vwPenjualanHdr where CreatedBy =:username and TransDate = CONVERT(char(10), GetDate(),126)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"feedData": ' . json_encode($feedData) . '}';
            else
                echo '{"feedData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ########  Get Total Penjualan ########*/
function getSaldoSummary(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select * from tblTransaksiSaldoHdr where tanggal =:dari";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataSaldo": ' . json_encode($feedData) . '}';
            else
                echo '{"dataSaldo": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalCashier() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();

            $sql = "EXEC spSalesSummaryCashier @dari =:dari,@sampai =:sampai, @WHSID=:WHSID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);        
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

           if ($feedData)
                echo '{"dataCashier": ' . json_encode($feedData) . '}';
            else
                echo '{"dataCashier": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalPayment() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select COUNT(Payment) as JumlahPayment, Payment, PaymentProvider, SUM(GrandTotal) as Total from tblTrnPOSPayment where TransDate >=:dari AND TransDate<=:sampai AND WHSID=:WHSID AND Status= 1 GROUP By Payment, PaymentProvider";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);    
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);  
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataPayment": ' . json_encode($feedData) . '}';
            else
                echo '{"dataPayment": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalBill() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select COUNT(TransID) as JumlahBill from vwPenjualanHdr where TransDate >=:dari AND TransDate<=:sampai AND WHSID=:WHSID AND Status= 1";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);    
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);  
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataBill": ' . json_encode($feedData) . '}';
            else
                echo '{"dataBill": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTotalPenjualanByPayment() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;
    $Payment = $data->Payment;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select SUM(GrandTotal) as Total from vwPenjualanHdr where CreatedBy =:username and Payment=:Payment and TransDate = CONVERT(char(10), GetDate(),126)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("Payment", $Payment, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"feedData": ' . json_encode($feedData) . '}';
            else
                echo '{"feedData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ########  Get Info Saldo Kas Awal ########*/
function DashGetSaloKasAwal() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;
    $token = $data->token;
    $lastCreated = $data->lastCreated;

    try {

            $feedData = '';
            $db = getDB();
            
            $sql = "select top(1) a.IdSaldo, a.tanggal, a.username, a.OutletId, a.buka,  ISNULL(a.KasAwal, 0) as kas_awal, a.tutup, ISNULL(a.KasAkhir,0) AS kas_akhir, a.catatan, b.registrasi, ISNULL(b.closing, 0) AS closing, b.seratus, b.limapuluh, b.duapuluh, b.sepuluh, b.limaribu, b.duaribu, b.seribu,b.limaratus, a.CreatedDate, a.LastUpdatedDate from tblTransaksiSaldoHdr  as a INNER JOIN tblTransaksiSaldoDtl as b ON a.IdSaldo = b.IdSaldo WHERE username=:username AND tanggal=:lastCreated ORDER BY tanggal";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("lastCreated", $lastCreated, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"feedData": ' . json_encode($feedData) . '}';
            else
                echo '{"noData":}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


/* ########  Get Info Saldo Kas Awal ########*/
function PosGetSaloKasAkhir() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;
    $lastCreated = $data->lastCreated;
    $token = $data->token;
    $systemToken = apiToken($username);

    try {

        if ($systemToken == $token) {
            $feedData = '';
            $db = getDB();
            
            $sql = "SELECT TOP(1) * FROM tblTransaksiSaldoHdr WHERE username=:username AND tanggal=:lastCreated ORDER BY tanggal";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("lastCreated", $lastCreated, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"registerData": ' . json_encode($feedData) . '}';
            else
                echo '{"registerData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTotalPendapatan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select SUM(Discount) as TotalDiscount, SUM(PPDAmount+PPNAmount) as TotalPajak, SUM(Pembelian) as Total, SUM(GrandTotal) as GrandTotal from vwPenjualanHdr where TransDate >=:dari and TransDate <=:sampai AND WHSID=:WHSID AND Status <> 3";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR); 
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);       
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);   
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataPendapatan": ' . json_encode($feedData) . '}';
            else
                echo '{"dataPendapatan": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function SendSMS(){
    $request = \Slim\Slim::getInstance()->request();
    try {
    	$fullUrl = 'http://gateway.onewaysms.co.id:10002/api.aspx?apiusername=APIH93UHRZNV4&apipassword=APIH93UHRZNV4TY09O&senderid=Sambu&mobileno=6282266664611&message=inipesantes&languagetype=1';
    }catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
	
}

function getCategoryPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {
            $feedData = '';
            $db = getDB();
            
            $sql = "select CategoryNamePOS, SUM(Qnty) as TotalItem, ROUND(SUM(UnitPrice),0) as TotalCategory from vwPenjualan where TransDate >=:dari and TransDate<=:sampai AND WHSID=:WHSID  and Status <> 3 GROUP By CategoryNamePOS";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);    
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);      
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);   
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"CategoryPenjualan": ' . json_encode($feedData) . '}';
            else
                echo '{"CategoryPenjualan": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalItemPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select ItemName, SUM(Qnty) as Qnty, UnitPrice, SUM(Qnty*UnitPrice) as Total, CategoryNamePOS  from vwPenjualan where TransDate >=:dari AND TransDate<=:sampai AND WHSID=:WHSID and Status <> 3 Group By ItemName, UnitPrice, CategoryNamePOS  order by ItemName";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);      
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);   
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataItemPenjualan": ' . json_encode($feedData) . '}';
            else
                echo '{"dataItemPenjualan": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalDiskonPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select COUNT(TotalDiscount) as JumlahDiskon, Promo_Name, SUM(TotalDiscount) as TotalDiskon from vwPenjualan where TransDate >=:dari and TransDate<=:sampai AND WHSID=:WHSID  and Status <> 3 and Promo_Name IS NOT NULL GROUP By Promo_Name order by Promo_Name";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);      
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);   
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataDiskonPenjualan": ' . json_encode($feedData) . '}';
            else
                echo '{"dataDiskonPenjualan": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTotalVoid() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {;
            $feedData = '';
            $db = getDB();
            
            $sql = "select SUM(Kembali) as Total, TransID, Kembali from vwPenjualanHdr where TransDate >=:dari and TransDate<=:sampai AND WHSID=:WHSID  and Status = 3 group by TransID, Kembali order by TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);  
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);      
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);   
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataVoid": ' . json_encode($feedData) . '}';
            else
                echo '{"dataVoid": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
/* ########  Get ITEM SALES ########*/
function getItemPenjualanByUser() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;

    try {
            $feedData = '';
            $db = getDB();
            
            $sql = "Select ISNULL(SUM(Qnty),0) TotalTerjual from vwPenjualan where CreatedBy=:username and TransDate = CONVERT(char(10), GetDate(),126)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getItemPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $username = $data->username;

    try {
            $feedData = '';
            $db = getDB();
            
            $sql = "Select * from vwPenjualan where TransDate = CONVERT(char(10), GetDate(),126)";
            $stmt = $db->prepare($sql);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function customer() {
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM pos_master_pelanggan WHERE inactive = '0'  ORDER BY nama_depan DESC";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"customerData": ' . json_encode($customerData) . '}';
            else
                echo '{"customerData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updateCustomer(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $id_pelanggan = $data->id_pelanggan;
    $cart_id = $data->cart_id;
    try {
            $db = getDB();

            $sql = "UPDATE pos_tbl_transaksi_cart SET id_pelanggan =:id_pelanggan where username=:username and cart_id=:cart_id and check_out = '0'";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("id_pelanggan", $id_pelanggan, PDO::PARAM_STR);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("cart_id", $cart_id, PDO::PARAM_STR);
            $stmt->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData){
                echo '{"cartData": ' . json_encode($cartData) . '}';
            }else{
                echo '{"cartData": ""}';
            }
                
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getPromo() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
            $db = getDB();

            $sql = "SELECT * FROM tblMstPromo WHERE Expired = '0' AND CONVERT (date, GETDATE()) >= StartDate and CONVERT (date, GETDATE()) <= ExpiredDate ORDER BY NEWID()";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $promoData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($promoData)
                echo '{"promoData": ' . json_encode($promoData) . '}';
            else
                echo '{"promoData": '.json_encode($type_promo).'}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getPromoauto() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
            $db = getDB();

            $sql = "SELECT * FROM vwPromoAuto WHERE CONVERT (date, GETDATE()) >= StartDate and CONVERT (date, GETDATE()) <= EndDate";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $promoData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($promoData)
                echo '{"promoAutoData": ' . json_encode($promoData) . '}';
            else
                echo '{"promoAutoData": '.json_encode($type_promo).'}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getPromoautoByID() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $ItemID = $data->ItemID;
    try {
            $db = getDB();

            $sql = "SELECT * FROM vwPromoAuto WHERE ItemID=:ItemID and CONVERT (date, GETDATE()) >= StartDate and CONVERT (date, GETDATE()) <= EndDate";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("ItemID", $ItemID, PDO::PARAM_STR);
            $stmt->execute();
            $promoData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($promoData)
                echo '{"promoAutoData": ' . json_encode($promoData) . '}';
            else
                echo '{"promoAutoData": '.json_encode($type_promo).'}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getBank() {
    try {
         if (1) {
            $bankData = '';
            $db = getDB();

            $sql = "SELECT * FROM pos_daftar_bank";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $bankData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($bankData)
                echo '{"bankData": ' . json_encode($bankData) . '}';
            else
                echo '{"bankData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updatePromo(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $id_promo = $data->id_promo;
    $cart_id = $data->cart_id;
    try {
            $db = getDB();

            $sql = "UPDATE pos_tbl_transaksi_cart SET id_promo =:id_promo where username=:username and cart_id=:cart_id and check_out = '0'";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("id_promo", $id_promo, PDO::PARAM_STR);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("cart_id", $cart_id, PDO::PARAM_STR);
            $stmt->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function sub_category() {
    try {

        if (1) {
            $subCategoryData = '';
            $db = getDB();

            $sql = "SELECT * FROM tblMstItemSubCategory where CategoryID = 24";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $subCategoryData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($subCategoryData)
                echo '{"subCategoryData": ' . json_encode($subCategoryData) . '}';
            else
                echo '{"subCategoryData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function stockNonProductHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select ItemID, ItemName, SubCategoryID, SubCategoryName, CategoryID, CategoryName, ISNULL(SUM(ISNULL(QntyAvailable,0)),0) as QntyAvailable from vwStockAvailable where WHSID IN (15, 16) and CategoryID IN (10, 3, 21) and ItemName LIKE :Itemname Group BY ItemID, ItemName, SubCategoryID, SubCategoryName, CategoryID, CategoryName HAVING ISNULL(SUM(ISNULL(QntyAvailable,0)),0)>0";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"prodData": ' . json_encode($customerData) . '}';
            else
                echo '{"prodData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function stockNonProduct() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select * from vwStockAvailable where WHSID IN (15, 16) and CategoryID IN (10, 3, 21) AND QntyAvailable > 0 and ItemName LIKE :Itemname";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function stockPackaging() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select ItemID, ItemName, SubCategoryID, SubCategoryName, CategoryID, CategoryName, ISNULL(SUM(ISNULL(QntyAvailable,0)),0) as QntyAvailable from vwStockAvailable where WHSID IN (15, 16) and CategoryID IN (2) and ItemName LIKE :Itemname Group BY ItemID, ItemName, SubCategoryID, SubCategoryName, CategoryID, CategoryName HAVING ISNULL(SUM(ISNULL(QntyAvailable,0)),0)>0";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function stockProductHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select ItemID, ItemName, SubCategoryID, SubCategoryID, CategoryNamePOS as CategoryName, CategoryIDPOS as CategoryID, ISNULL(SUM(ISNULL(QntyAvailable,0)),0) as QntyAvailable from vwStockAvailable where WHSID IN (15, 16) and ItemName LIKE :Itemname Group BY ItemID, ItemName, SubCategoryID, CategoryNamePOS, CategoryIDPOS";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"prodData": ' . json_encode($customerData) . '}';
            else
                echo '{"prodData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function ProductForRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->ItemName."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select * from vwItem as a where InActive= 0 AND ItemName like :Itemname order By ItemName";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function stockProduct() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select ItemID, ItemName, SubCategoryID, CategoryNamePOS as CategoryName, CategoryIDPOS as CategoryID, ISNULL(SUM(ISNULL(QntyAvailable,0)),0) as QntyAvailable from vwStockAvailable  where WHSID IN (15, 16) and ItemName LIKE :Itemname Group BY ItemID, ItemName, SubCategoryID, CategoryNamePOS, CategoryIDPOS";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function stockProductAvailable() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select ItemID, ItemName, ISNULL(SUM(QntyAvailable), 0) as Qnty, UOMName, SubCategoryID, CategoryNamePOS as CategoryName, CategoryIDPOS as CategoryID, ISNULL(SUM(ISNULL(QntyAvailable,0)),0) as QntyAvailable, WHSID  from vwStockAvailable where (WHSID IN (15, 16) and ItemName LIKE :Itemname Group By ItemID, ItemName, UOMName, SubCategoryName, WHSID, SubCategoryID, CategoryNamePOS, CategoryIDPOS";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"DataStock": ' . json_encode($customerData) . '}';
            else
                echo '{"DataStock": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function allproduct() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItem where FinishGood = 1 AND CategoryID IN (20, 24, 1) and InActive = '0' and SubCategoryID NOT IN (102) AND ItemName like :Itemname  or SubCategoryID IN (19) and SubCategoryID NOT IN (102) AND ItemName like :Itemnames  order by SubCategoryName ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->bindParam('Itemnames', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getSubCategory() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT Distinct SubCategoryID, SubCategoryName FROM vwItem where FinishGood = 1 AND CategoryID IN (20, 24, 1) and InActive = '0' and SubCategoryID NOT IN (102) or SubCategoryID IN (19) and SubCategoryID NOT IN (102)  order by SubCategoryName ASC";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"dataSubCategory": ' . json_encode($customerData) . '}';
            else
                echo '{"dataSubCategory": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function productCategory() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $SubCategoryID = $data->SubCategoryID;
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItem where CategoryIDPOS =:SubCategoryID  order by SubCategoryName ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('SubCategoryID', $SubCategoryID, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getProductPOS() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItem where FinishGood = 1 AND InActive = 0 AND CategoryIDPOS IS NOT NULL AND ItemName like :Itemname  order by CategoryNamePOS ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getProductRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItemRO where InActive = 0 order by CategoryNamePOS ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getCategoryPOS() {
    try {

        if (1) {
            $categoryData = '';
            $db = getDB();

            $sql = "SELECT CategoryID as SubCategoryID, CategoryName as SubCategoryName FROM tblMstItemCategory";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $categoryData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($categoryData)
                echo '{"categoryData": ' . json_encode($categoryData) . '}';
            else
                echo '{"categoryData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function product() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItem where FinishGood = 1 AND CategoryID IN (20, 24, 1) and InActive = '0' and SubCategoryID NOT IN (102) AND ItemName like :Itemname  or SubCategoryID IN (19) and SubCategoryID NOT IN (102) AND ItemName like :Itemnames  order by SubCategoryName ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->bindParam('Itemnames', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getProductSample() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->Itemname."%";
    try {

        if (1) {
            $customerData = '';
            $db = getDB();

            $sql = "SELECT * FROM vwItem where InActive = '0' and FinishGood = 1 AND ItemName like :Itemname  order by SubCategoryName ASC, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getSummary() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $cart_id = $data->cart_id;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT cart_id, COUNT(product_id) as total_item, SUM(quantity*price) as total FROM vwPOSTrnCart WHERE username=:username and cart_id=:cart_id and check_out = '0' Group BY cart_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("cart_id", $cart_id, PDO::PARAM_INT);
            $stmt->execute();
            $summaryData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($summaryData)
                echo '{"summaryData": ' . json_encode($summaryData) . '}';
            else
                echo '{"summaryData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getSummaryPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $cart_id = $data->cart_id;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT TransID, COUNT(ItemID) as total_item, Pembelian,  SUM(Qnty*UnitPrice) as SubTotal, GrandTotal,  PPNAmount, PPDAmount, PromoCode, DiscountAbbr, SUM(TotalDiscount) as Discount ,Dibayar,Kembali, Payment, Provider, Status  FROM vwPenjualan WHERE TransID=:TransID  Group BY TransID, Pembelian, GrandTotal, PPNAmount, PPDAmount, PromoCode, DiscountAbbr, Discount ,Dibayar,Kembali, Payment, Provider, Status";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->execute();
            $summaryData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($summaryData)
                echo '{"summaryData": ' . json_encode($summaryData) . '}';
            else
                echo '{"summaryData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getSalesSummaryByUser() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {
            $db = getDB();

            $sql = "EXEC spSalesSummaryByUser @dari=:dari, @sampai=:sampai, @username=:username";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->execute();
            $summaryDataByUser = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($summaryDataByUser)
                echo '{"summaryDataByUser": ' . json_encode($summaryDataByUser) . '}';
            else
                echo '{"summaryDataByUser": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getSalesSummary() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {
            $db = getDB();

            $sql = "EXEC spSalesSamurry @dari=:dari, @sampai=:sampai, @WHSID=:WHSID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $summaryData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($summaryData)
                echo '{"summarySalesData": ' . json_encode($summaryData) . '}';
            else
                echo '{"summarySalesData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getVoucher(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $payment_number = $data->PaymentNumber;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT * FROM pos_tbl_voucher WHERE nomor_voucher='17-0728-KAID' and sudah_digunakan = '0' and CONVERT (date, GETDATE()) >= aktif_dari and CONVERT (date, GETDATE()) < aktif_hingga";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("payment_number", $payment_number, PDO::PARAM_STR);
            $stmt->execute();
            $DataVoucher = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataVoucher)
                echo '{"DataVoucher": ' . json_encode($DataVoucher) . '}';
            else
                echo '{"DataVoucher": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getPenjualanHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT * FROM vwPenjualan WHERE TransID=:TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"DataPenjualanHdr": ' . json_encode($cartData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getPenjualanDtl() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT * FROM vwPenjualan WHERE TransID=:TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"DataPenjualanDtl": ' . json_encode($cartData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $type_cart = $data->type_cart;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' and type_cart=:type_cart  ORDER BY cart_item_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("type_cart", $type_cart, PDO::PARAM_STR);
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"noData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updateCartBTB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $cart_id = $data->cart_id;
    $trans_id = $data->trans_id;
    $quantity = $data->quantity;
    $remark = $data->remark;
    $product_id = $data->product_id;
    try {
            $db = getDB();

            $sql = "UPDATE tblTrnCartDtl SET quantity =:quantity, product_id =:product_id,trans_id=:trans_id, remark=:remark where cart_id = :cart_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("quantity", $quantity, PDO::PARAM_STR);
            $stmt->bindParam("product_id", $product_id, PDO::PARAM_STR);
            $stmt->bindParam("trans_id", $trans_id, PDO::PARAM_STR);
            $stmt->bindParam("remark", $remark, PDO::PARAM_STR);
            $stmt->bindParam("cart_id", $cart_id, PDO::PARAM_STR);
            $stmt->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updateCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $cart_item_id = $data->cart_item_id;
    $quantity = $data->quantity;
    $remark = $data->remark;
    $token = $data->token;
    $systemToken = apiToken($username);
    try {
            $db = getDB();

            $sql = "UPDATE tblTrnCartDtl SET quantity =:quantity, remark=:remark where cart_item_id=:cart_item_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("quantity", $quantity, PDO::PARAM_INT);
            $stmt->bindParam("remark", $remark, PDO::PARAM_INT);
            $stmt->bindParam("cart_item_id", $cart_item_id, PDO::PARAM_INT);
            $stmt->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function deleteAllCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    try {
            $db = getDB();

            $sql = "DELETE tblTrnCartHdr";
            $stmt = $db->prepare($sql);
            $stmt->execute();

            $sql2 = "DELETE tblTrnCartDtl";
            $stmt2 = $db->prepare($sql2);
            $stmt2->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function deletePageCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    try {
            $db = getDB();

            $sql = "DELETE tblTrnCartHdr where username=:username1";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username1", $username, PDO::PARAM_STR);
            $stmt->execute();

            $sql2 = "DELETE tblTrnCartDtl where username=:username2";
            $stmt2 = $db->prepare($sql2);
            $stmt2->bindParam("username2", $username, PDO::PARAM_STR);
            $stmt2->execute();

            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username3 and check_out = '0' ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username3", $username, PDO::PARAM_STR);

            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function deleteCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $cart_item_id = $data->cart_item_id;
    $token = $data->token;
    $systemToken = apiToken($username);
    try {
            $db = getDB();

            $sql = "DELETE tblTrnCartDtl where cart_item_id=:cart_item_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("cart_item_id", $cart_item_id, PDO::PARAM_INT);
            $stmt->execute();

            $db = null;

            echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertCart() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $ItemID = $data->ItemID;
    $quantity = $data->quantity;
    $price = $data->price;
    $id_pelanggan = $data->id_pelanggan;
    $type_cart = $data->type_cart;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSCart @username=:username,@id_pelanggan=:id_pelanggan, @product_id=:ItemID, @type_cart=:type_cart, @quantity=:quantity, @price=:price, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('username', $username, PDO::PARAM_STR);
            $stmt->bindParam('id_pelanggan', $id_pelanggan, PDO::PARAM_STR);
            $stmt->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('quantity', $quantity, PDO::PARAM_STR);
            $stmt->bindParam('price', $price, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username2 and check_out = 0 ORDER BY cart_item_id";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam("username2", $username, PDO::PARAM_STR);
            
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function insertCartBTB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $username = $data->username;
    $ItemID = $data->ItemID;
    $quantity = $data->quantity;
    $trans_id = $data->trans_id;
    $price = $data->price;
    $id_pelanggan = $data->id_pelanggan;
    $type_cart = $data->type_cart;
    $production_date = $data->production_date;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSCartBTB @username=:username,@id_pelanggan=:id_pelanggan, @product_id=:ItemID,@type_cart=:type_cart,@trans_id=:trans_id, @production_date=:production_date, @quantity=:quantity, @price=:price, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('username', $username, PDO::PARAM_STR);
            $stmt->bindParam('id_pelanggan', $id_pelanggan, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            $stmt->bindParam('trans_id', $trans_id, PDO::PARAM_STR);
            $stmt->bindParam('production_date', $production_date, PDO::PARAM_STR);
            $stmt->bindParam('quantity', $quantity, PDO::PARAM_INT);
            $stmt->bindParam('price', $price, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and check_out = 0 ORDER BY cart_item_id";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function insertPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $cart_id = $data->cart_id;
    $id_pelanggan = $data->id_pelanggan;
    $username = $data->username;
    $catatan = $data->catatan;
    $payment = $data->payment;
    $provider = $data->provider;
    $payment_number = $data->payment_number;
    $payment_atachment = $data->payment_atachment;
    $diskon = $data->diskon;
    $diskon_persen = $data->diskon_persen;
    $jumlah_diskon = $data->jumlah_diskon;
    $ppn = $data->ppn_rupiah;
    $promo = $data->PromoCode;
    $dibayar = $data->dibayar;
    $kembalian = $data->kembalian;
    $total = $data->total;
    $RekeningTujuan = $data->RekeningTujuan;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSPenjualanSave @cart_id=:cart_id, @CustomerID=:id_pelanggan, @Remark=:catatan, @RekeningTujuan=:RekeningTujuan, @Payment=:payment, @Provider=:provider, @PaymentNumber=:payment_number, @PaymentAtch=:payment_atachment, @DiscAbbr=:diskon, @DiscPersen=:diskon_persen, @DiscRupiah=:jumlah_diskon,@PPN=:ppn, @PromoCode=:promo, @Dibayar=:dibayar, @Kembalian=:kembalian, @Total=:total, @UserID=:username, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('cart_id', $cart_id, PDO::PARAM_STR);
            $stmt->bindParam('id_pelanggan', $id_pelanggan, PDO::PARAM_STR);
            $stmt->bindParam('catatan', $catatan, PDO::PARAM_STR);
            $stmt->bindParam('RekeningTujuan', $RekeningTujuan, PDO::PARAM_STR);
            $stmt->bindParam('payment', $payment, PDO::PARAM_STR);
            $stmt->bindParam('provider', $provider, PDO::PARAM_STR);
            $stmt->bindParam('payment_number', $payment_number, PDO::PARAM_STR);
            $stmt->bindParam('payment_atachment', $payment_atachment, PDO::PARAM_STR);
            $stmt->bindParam('diskon', $diskon, PDO::PARAM_STR);
            $stmt->bindParam('diskon_persen', $diskon_persen, PDO::PARAM_STR);
            $stmt->bindParam('jumlah_diskon', $jumlah_diskon, PDO::PARAM_STR);
            $stmt->bindParam('ppn', $ppn, PDO::PARAM_STR);
            $stmt->bindParam('promo', $promo, PDO::PARAM_STR);
            $stmt->bindParam('dibayar', $dibayar, PDO::PARAM_STR);
            $stmt->bindParam('kembalian', $kembalian, PDO::PARAM_STR);
            $stmt->bindParam('total', $total, PDO::PARAM_STR);
            $stmt->bindParam('username', $username, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and cart_id=:cart_id ORDER BY cart_item_id";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam('cart_id', $cart_id, PDO::PARAM_STR);
            
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $TransDate = $data->TransDate;
    $WHSID = $data->WHSID;
    $SupplierID = '01/TUN';
    $RekeningTujuan = $data->RekeningTujuan;
    $Payment = $data->Payment;
    $Provider = $data->Provider;
    $PaymentNumber = $data->PaymentNumber;
    $PaymentAtch = $data->PaymentAtch;
    $Pembelian = $data->Pembelian;
    $DPPPajakRest = $data->DPPPajakRest;
    $DPPPPN = $data->DPPPPN;
    $Dining = $data->Dining;
    $DiscountAbbr = $data->DiscountAbbr;
    $Discount = $data->Discount;
    $PromoCode = $data->PromoCode;
    $PPD = $data->PPD;
    $PPDAmount = $data->PPDAmount;
    $PPN = $data->PPN;
    $PPNAmount = $data->PPNAmount;
    $SubTotal = $data->SubTotal;
    $GrandTotal = $data->GrandTotal;
    $Pembulatan = $data->Pembulatan;
    $Dibayar = $data->Dibayar;
    $Kembalian = $data->Kembalian;
    $Total = $data->Total;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSPenjualanHdrSave @TransID=:TransID, @TransDate=:TransDate, @WHSID=:WHSID, @SupplierID=:SupplierID, @Dining=:Dining, @RekeningTujuan=:RekeningTujuan, @Payment=:Payment, @Provider=:Provider, @PaymentNumber=:PaymentNumber, @PaymentAtch=:PaymentAtch,@Pembelian=:Pembelian,  @DPPPajakRest=:DPPPajakRest, @DPPPPN=:DPPPPN, @DiscountAbbr=:DiscountAbbr, @Discount=:Discount, @PromoCode=:PromoCode, @PPD=:PPD, @PPDAmount=:PPDAmount, @PPN=:PPN, @PPNAmount=:PPNAmount,  @SubTotal=:SubTotal, @Pembulatan=:Pembulatan, @GrandTotal=:GrandTotal, @Dibayar=:Dibayar, @Kembali=:Kembali, @Remark=:Remark, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('SupplierID', $SupplierID, PDO::PARAM_STR);
            $stmt->bindParam('Dining', $Dining, PDO::PARAM_STR);
            $stmt->bindParam('RekeningTujuan', $RekeningTujuan, PDO::PARAM_STR);
            $stmt->bindParam('Payment', $Payment, PDO::PARAM_STR);
            $stmt->bindParam('Provider', $Provider, PDO::PARAM_STR);
            $stmt->bindParam('PaymentNumber', $PaymentNumber, PDO::PARAM_STR);
            $stmt->bindParam('PaymentAtch', $PaymentAtch, PDO::PARAM_STR);
            $stmt->bindParam('Pembelian', $Pembelian, PDO::PARAM_STR);
            $stmt->bindParam('DPPPajakRest', $DPPPajakRest, PDO::PARAM_STR);
            $stmt->bindParam('DPPPPN', $DPPPPN, PDO::PARAM_STR);
            $stmt->bindParam('DiscountAbbr', $DiscountAbbr, PDO::PARAM_STR);
            $stmt->bindParam('Discount', $Discount, PDO::PARAM_STR);
            $stmt->bindParam('PromoCode', $PromoCode, PDO::PARAM_STR);
            $stmt->bindParam('PPD', $PPD, PDO::PARAM_STR);
            $stmt->bindParam('PPDAmount', $PPDAmount, PDO::PARAM_STR);
            $stmt->bindParam('PPN', $PPN, PDO::PARAM_STR);
            $stmt->bindParam('PPNAmount', $PPNAmount, PDO::PARAM_STR);
            $stmt->bindParam('SubTotal', $SubTotal, PDO::PARAM_STR);
            $stmt->bindParam('Pembulatan', $Pembulatan, PDO::PARAM_STR);
            $stmt->bindParam('GrandTotal', $GrandTotal, PDO::PARAM_STR);
            $stmt->bindParam('Dibayar', $Dibayar, PDO::PARAM_STR);
            $stmt->bindParam('Kembali', $Kembali, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT|PDO::PARAM_INPUT_OUTPUT, 12);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from tblTrnPenjualanHdr where TransID=:TransID2");
            $stmt2->bindParam('TransID2', $TransID, PDO::PARAM_STR);
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"DataHdr": ' . json_encode($TransID) . '}';
            else
                echo '{"DataHdr": ""}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanDtl() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    $Qnty = $data->Qnty;
    $UnitPrice = $data->UnitPrice;
    $SellingPrice = $data->SellingPrice;
    $Discount = $data->Discount;
    $PromoCode = $data->PromoCode;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSPenjualanDtlSave @TransID=:TransID, @ItemID=:ItemID, @Qnty=:Qnty, @UnitPrice=:UnitPrice, @SellingPrice=:SellingPrice, @Discount=:Discount, @PromoCode=:PromoCode, @Remark=:Remark, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('UnitPrice', $UnitPrice, PDO::PARAM_STR);
            $stmt->bindParam('SellingPrice', $SellingPrice, PDO::PARAM_STR);
            $stmt->bindParam('Discount', $Discount, PDO::PARAM_STR);
            $stmt->bindParam('PromoCode', $PromoCode, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT * from tblTrnPenjualanDtl where TransID=:TransID2x");
            $stmt2->bindParam('TransID2x', $TransID, PDO::PARAM_STR);
            $stmt2->execute();
            $TransIDs = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransIDs)
                echo '{"DataDtl": ' . json_encode($TransIDs) . '}';
            else
                echo '{"DataDtl": ""}';

    } catch (PDOException $e) {
        echo '{"oops error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransID() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $WHSID = $data->WHSID;
	$ToolYEAR = "'%" . date("Y") . "" . $WHSID . "%'";
    try {
            $db = getDB();

            $sql = "SELECT TransID, GrandTotal, TransDate, CreatedBy from vwPenjualanHdr WHERE MONTH(TransDate) = MONTH(GETDATE()) AND YEAR(TransDate) = YEAR(GETDATE()) and TransID like '%2020%' and WHSID=:WHSID  order by LEFT(TransID, 6) desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $TransIDl = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransIDl)
                echo '{"TransID": ' . json_encode($TransIDl) . '}';
            else
                echo '{"TransID": ' . json_encode($ToolYEAR) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . $ToolYEAR . '}}';
    }
}
function getTransDetail() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $WHSID = $data->WHSID;
    try {
            $db = getDB();

            $sql = "SELECT TransID, ItemID, Qnty, TransDate, CreatedBy, CreatedDate from vwPenjualan WHERE MONTH(TransDate) = MONTH(GETDATE()) AND YEAR(TransDate) = YEAR(GETDATE()) and WHSID=:WHSID order by RIGHT(TransID, 4) desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $TransID = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"ItemID": ' . json_encode($TransID) . '}';
            else
                echo '{"ItemID": ""}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function insertPaymentSyn() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $TransDate = $data->TransDate;
    $Status = $data->Status;
    $WHSID = $data->WHSID;
    $Payment = $data->Payment;
    $PaymentProvider = $data->PaymentProvider;
    $GrandTotal = $data->GrandTotal;
    $CreatedBy = $data->CreatedBy;
    $Flag = 0;
    try {
            $db = getDB();

            $sql = "Exec spPOSPaymentSave @TransID=:TransID, @TransDate=:TransDate, @Status=:Status, @WHSID=:WHSID, @Payment=:Payment, @PaymentProvider=:PaymentProvider, @GrandTotal=:GrandTotal, @CreatedBy=:CreatedBy, @Flag=:Flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('Status', $Status, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('Payment', $Payment, PDO::PARAM_STR);
            $stmt->bindParam('PaymentProvider', $PaymentProvider, PDO::PARAM_STR);
            $stmt->bindParam('GrandTotal', $GrandTotal, PDO::PARAM_STR);
            $stmt->bindParam('CreatedBy', $CreatedBy, PDO::PARAM_STR);
            $stmt->bindParam('Flag', $Flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from tblTrnPOSPayment where TransID=:TransID2 desc");
            $stmt2->bindParam('TransID2', $TransID, PDO::PARAM_STR);
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"TransID": ' . json_encode($TransID) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanHdrSyn() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransIDPOS = $data->TransIDPOS;
    $TransDate = $data->TransDate;
    $WHSID = $data->WHSID;
    $SupplierID = $data->SupplierID;
    $RekeningTujuan = $data->RekeningTujuan;
    $Payment = $data->Payment;
    $Provider = $data->Provider;
    $PaymentNumber = $data->PaymentNumber;
    $PaymentAtch = $data->PaymentAtch;
    $Pembelian = $data->Pembelian;
    $DPPPajakRest = $data->DPPPajakRest;
    $DPPPPN = $data->DPPPPN;
    $DiscountAbbr = $data->DiscountAbbr;
    $Discount = $data->Discount;
    $PromoCode = $data->PromoCode;
    $PPD = $data->PPD;
    $PPDAmount = $data->PPDAmount;
    $PPN = $data->PPN;
    $PPNAmount = $data->PPNAmount;
    $SubTotal = $data->SubTotal;
    $Pembulatan = $data->Pembulatan;
    $Pembulatan = $data->Pembulatan;
    $Dibayar = $data->Dibayar;
    $Kembalian = $data->Kembalian;
    $Total = $data->Total;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSDOTunaiHdrSynSave @TransIDPOS=:TransIDPOS, @TransDate=:TransDate, @WHSID=:WHSID, @SupplierID=:SupplierID, @RekeningTujuan=:RekeningTujuan, @Payment=:Payment, @Provider=:Provider, @PaymentNumber=:PaymentNumber, @PaymentAtch=:PaymentAtch,@Pembelian=:Pembelian,  @DPPPajakRest=:DPPPajakRest, @DPPPPN=:DPPPPN, @DiscountAbbr=:DiscountAbbr, @Discount=:Discount, @PromoCode=:PromoCode, @PPD=:PPD, @PPDAmount=:PPDAmount, @PPN=:PPN, @PPNAmount=:PPNAmount,  @SubTotal=:SubTotal, @Pembulatan=:Pembulatan, @GrandTotal=:GrandTotal, @Dibayar=:Dibayar, @Kembali=:Kembali, @Remark=:Remark, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransIDPOS', $TransIDPOS, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('SupplierID', $SupplierID, PDO::PARAM_STR);
            $stmt->bindParam('RekeningTujuan', $RekeningTujuan, PDO::PARAM_STR);
            $stmt->bindParam('Payment', $Payment, PDO::PARAM_STR);
            $stmt->bindParam('Provider', $Provider, PDO::PARAM_STR);
            $stmt->bindParam('PaymentNumber', $PaymentNumber, PDO::PARAM_STR);
            $stmt->bindParam('PaymentAtch', $PaymentAtch, PDO::PARAM_STR);
            $stmt->bindParam('Pembelian', $Pembelian, PDO::PARAM_STR);
            $stmt->bindParam('DPPPajakRest', $DPPPajakRest, PDO::PARAM_STR);
            $stmt->bindParam('DPPPPN', $DPPPPN, PDO::PARAM_STR);
            $stmt->bindParam('DiscountAbbr', $DiscountAbbr, PDO::PARAM_STR);
            $stmt->bindParam('Discount', $Discount, PDO::PARAM_STR);
            $stmt->bindParam('PromoCode', $PromoCode, PDO::PARAM_STR);
            $stmt->bindParam('PPD', $PPD, PDO::PARAM_STR);
            $stmt->bindParam('PPDAmount', $PPDAmount, PDO::PARAM_STR);
            $stmt->bindParam('PPN', $PPN, PDO::PARAM_STR);
            $stmt->bindParam('PPNAmount', $PPNAmount, PDO::PARAM_STR);
            $stmt->bindParam('SubTotal', $SubTotal, PDO::PARAM_STR);
            $stmt->bindParam('Pembulatan', $Pembulatan, PDO::PARAM_STR);
            $stmt->bindParam('GrandTotal', $GrandTotal, PDO::PARAM_STR);
            $stmt->bindParam('Dibayar', $Dibayar, PDO::PARAM_STR);
            $stmt->bindParam('Kembali', $Kembali, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from tblTrnPenjualanHdr where TransID=:TransID2 order by CreatedDate desc");
            $stmt2->bindParam('TransID2', $UserID, PDO::PARAM_STR);
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"DataHdr": ' . json_encode($TransID) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanDtlSyn() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransIDPOS = $data->TransIDPOS;
    $ItemID = $data->ItemID;
    $Remark = $data->Remark;
    $Qnty = $data->Qnty;
    $UnitPrice = $data->UnitPrice;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSDOTunaiDtlSynSave @TransIDPOS=:TransIDPOS, @ItemID=:ItemID, @Remark=:Remark,@Qnty=:Qnty,@UnitPrice=:UnitPrice, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransIDPOS', $TransIDPOS, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('UnitPrice', $UnitPrice, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from pos_tbl_trn_penjualan_detail order by CreatedDate desc");
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"DataDtl": ' . json_encode($TransID) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanHdrSynV1() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransIDPOS = $data->TransIDPOS;
    $TransDate = $data->TransDate;
    $WHSID = $data->WHSID;
    $SupplierID = $data->SupplierID;
    $RekeningTujuan = $data->RekeningTujuan;
    $Payment = $data->Payment;
    $Provider = $data->Provider;
    $PaymentNumber = $data->PaymentNumber;
    $PaymentAtch = $data->PaymentAtch;
    $Pembelian = $data->Pembelian;
    $DPPPajakRest = $data->DPPPajakRest;
    $DPPPPN = $data->DPPPPN;
    $DiscountAbbr = $data->DiscountAbbr;
    $Discount = $data->Discount;
    $PromoCode = $data->PromoCode;
    $PPD = $data->PPD;
    $PPDAmount = $data->PPDAmount;
    $PPN = $data->PPN;
    $PPNAmount = $data->PPNAmount;
    $SubTotal = $data->SubTotal;
    $Pembulatan = $data->Pembulatan;
    $Pembulatan = $data->Pembulatan;
    $Dibayar = $data->Dibayar;
    $Kembalian = $data->Kembalian;
    $Total = $data->Total;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSPenjualanHdrSynSave @TransIDPOS=:TransIDPOS, @TransDate=:TransDate, @WHSID=:WHSID, @SupplierID=:SupplierID, @RekeningTujuan=:RekeningTujuan, @Payment=:Payment, @Provider=:Provider, @PaymentNumber=:PaymentNumber, @PaymentAtch=:PaymentAtch,@Pembelian=:Pembelian,  @DPPPajakRest=:DPPPajakRest, @DPPPPN=:DPPPPN, @DiscountAbbr=:DiscountAbbr, @Discount=:Discount, @PromoCode=:PromoCode, @PPD=:PPD, @PPDAmount=:PPDAmount, @PPN=:PPN, @PPNAmount=:PPNAmount,  @SubTotal=:SubTotal, @Pembulatan=:Pembulatan, @GrandTotal=:GrandTotal, @Dibayar=:Dibayar, @Kembali=:Kembali, @Remark=:Remark, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransIDPOS', $TransIDPOS, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('SupplierID', $SupplierID, PDO::PARAM_STR);
            $stmt->bindParam('RekeningTujuan', $RekeningTujuan, PDO::PARAM_STR);
            $stmt->bindParam('Payment', $Payment, PDO::PARAM_STR);
            $stmt->bindParam('Provider', $Provider, PDO::PARAM_STR);
            $stmt->bindParam('PaymentNumber', $PaymentNumber, PDO::PARAM_STR);
            $stmt->bindParam('PaymentAtch', $PaymentAtch, PDO::PARAM_STR);
            $stmt->bindParam('Pembelian', $Pembelian, PDO::PARAM_STR);
            $stmt->bindParam('DPPPajakRest', $DPPPajakRest, PDO::PARAM_STR);
            $stmt->bindParam('DPPPPN', $DPPPPN, PDO::PARAM_STR);
            $stmt->bindParam('DiscountAbbr', $DiscountAbbr, PDO::PARAM_STR);
            $stmt->bindParam('Discount', $Discount, PDO::PARAM_STR);
            $stmt->bindParam('PromoCode', $PromoCode, PDO::PARAM_STR);
            $stmt->bindParam('PPD', $PPD, PDO::PARAM_STR);
            $stmt->bindParam('PPDAmount', $PPDAmount, PDO::PARAM_STR);
            $stmt->bindParam('PPN', $PPN, PDO::PARAM_STR);
            $stmt->bindParam('PPNAmount', $PPNAmount, PDO::PARAM_STR);
            $stmt->bindParam('SubTotal', $SubTotal, PDO::PARAM_STR);
            $stmt->bindParam('Pembulatan', $Pembulatan, PDO::PARAM_STR);
            $stmt->bindParam('GrandTotal', $GrandTotal, PDO::PARAM_STR);
            $stmt->bindParam('Dibayar', $Dibayar, PDO::PARAM_STR);
            $stmt->bindParam('Kembali', $Kembali, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from tblTrnPenjualanHdr where TransID=:TransID2 order by CreatedDate desc");
            $stmt2->bindParam('TransID2', $UserID, PDO::PARAM_STR);
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"DataHdr": ' . json_encode($TransID) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertPenjualanDtlSynV1() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransIDPOS = $data->TransIDPOS;
    $ItemID = $data->ItemID;
    $Remark = $data->Remark;
    $Qnty = $data->Qnty;
    $UnitPrice = $data->UnitPrice;
    $SellingPrice = $data->SellingPrice;
    $Discount = $data->Discount;
    $PromoCode = $data->PromoCode;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSPenjualanDtlSynSave @TransIDPOS=:TransIDPOS, @ItemID=:ItemID, @Remark=:Remark,@Qnty=:Qnty,@UnitPrice=:UnitPrice, @SellingPrice=:SellingPrice, @Discount=:Discount, @PromoCode=:PromoCode,@UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransIDPOS', $TransIDPOS, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('UnitPrice', $UnitPrice, PDO::PARAM_STR);
            $stmt->bindParam('SellingPrice', $SellingPrice, PDO::PARAM_STR);
            $stmt->bindParam('Discount', $Discount, PDO::PARAM_STR);
            $stmt->bindParam('PromoCode', $PromoCode, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();

            $stmt2 = $db->prepare("SELECT TOP 1 * from tblTrnPenjualanDtl order by CreatedDate desc");
            $stmt2->execute();
            $TransID = $stmt2->fetchAll(PDO::FETCH_OBJ);

            $db = null; 
            if ($TransID)
                echo '{"DataDtl": ' . json_encode($TransID) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function postWO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $ROID = $data->ROID;
    $TransDate = $data->TransDate;
    $EstimasiDate = $data->EstimasiDate;
    $ItemID = $data->ItemID;
    $Qnty = $data->Qnty;
    $Remark = $data->Remark;
    $JenisBOM = $data->JenisBOM;
    $UserID = $data->UserID;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spWOSave @ROID=:ROID, @TransDate=:TransDate, @EstimasiDate=:EstimasiDate, @ItemID=:ItemID, @Qnty=:Qnty, @Remark=:Remark, @JenisBOM=:JenisBOM, @UserID=:UserID, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('ROID', $ROID, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('EstimasiDate', $EstimasiDate, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('JenisBOM', $JenisBOM, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
            
            $db = null; 
             echo '{"success":{"text":"WO telah berhasil"}}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertHdrRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $OutletID = $data->OutletID;
    $EstimasiDate = $data->EstimasiDate;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    try {
            $db = getDB();
            $sql = "INSERT INTO tblTrnROHeader (TransID, OutletID, TransDate, EstimasiDate, Remark, Status,CreatedBy, CreatedDate, UpdatedBy, UpdatedDate, IPAddress) VALUES (:TransID, :OutletID, CONVERT(char(10), GetDate(),126), :EstimasiDate, :Remark,0, :UserID, GetDate(), NULL, GetDate(), NULL)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('OutletID', $OutletID, PDO::PARAM_STR);
            $stmt->bindParam('EstimasiDate', $EstimasiDate, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->execute();

            $sql1 = "SELECT * FROM tblTrnROHeader WHERE TransID=:TransID2";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("TransID2", $TransID, PDO::PARAM_STR);
            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"suksesHeader": ' . json_encode($cartData) . '}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function insertDtlRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    $Qty = $data->Qty;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    try {
            $db = getDB();
            $sql = "INSERT INTO tblTrnRODetail (TransID, ItemID, Qty, StatusWO, Remark,CreatedBy, CreatedDate, UpdatedBy, UpdatedDate, IPAddress) VALUES (:TransID, :ItemID, :Qty, 0, :Remark, :UserID, GETDATE(), NULL, NULL, NULL)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Qty', $Qty, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->execute();
            
            $sql1 = "SELECT * FROM tblTrnRODetail WHERE TransID=:TransID2";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("TransID2", $TransID, PDO::PARAM_STR);
            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"suksesDetail": ' . json_encode($cartData) . '}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function editRODtl() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    $Qty = $data->Qnty;

    try {
            $db = getDB();
            $sql = "UPDATE tblTrnRODetail SET Qty=:Qty where TransID=:TransID AND ItemID=:ItemID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('Qty', $Qty, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->execute();
            
            echo '{"success":{"text":"Hapus RO telah berhasil"}}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function deleteRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;

    try {
            $db = getDB();
            $sql = "Delete From tblTrnROHeader where TransID=:TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->execute();

            $sql1 = "Delete From tblTrnRODetail where TransID=:TransID1";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam('TransID1', $TransID, PDO::PARAM_STR);
            $stmt1->execute();
            
            echo '{"success":{"text":"Hapus RO telah berhasil"}}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getROID(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $OutletID = $data->OutletID;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT RIGHT('0000' + CAST((ISNULL(MAX(CAST(LEFT(TransID, 4) AS BIGINT)), 0) + 1)  AS VARCHAR), 4) + '/' + RIGHT('000' + CAST(15 AS VARCHAR), 3)  + '/' + RIGHT('00' + CAST(MONTH(GETDATE()) AS VARCHAR), 2)  + CAST(YEAR(GETDATE()) AS VARCHAR)  as ROID FROM tblTrnROHeader WHERE OutletID = :OutletID AND MONTH(TransDate) = MONTH(GETDATE()) AND YEAR(TransDate) = YEAR(GETDATE())";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('OutletID', $OutletID, PDO::PARAM_STR);
            $stmt->execute();
            $DataRO = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataRO)
                echo '{"ROID": ' . json_encode($DataRO) . '}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getRO() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
        if (1) {
            $db = getDB();

            $sql = "select * from tblTrnROHeader where Status = '0'";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $DataRO = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataRO)
                echo '{"DataRO": ' . json_encode($DataRO) . '}';
            else
                echo '{"DataRO": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getRODetail() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
        if (1) {
            $db = getDB();

            $sql = "select * from vwRO";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $DataRODetail = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataRODetail)
                echo '{"DataRODetail": ' . json_encode($DataRODetail) . '}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getROBTB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {
        if (1) {
            $db = getDB();

            $sql = "select * from tblTrnROHeader where Status=2";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $DataRO = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataRO)
                echo '{"DataRO": ' . json_encode($DataRO) . '}';
            else
                echo '{"DataRO": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getROBTBDetail() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = "%".$data->ItemName."%";
    try {
        if (1) {
            $db = getDB();

            $sql = "select * from vwRO where Status=2 and ApprovedBy IS NULL and ItemName like :Itemname";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $DataRODetail = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataRODetail)
                echo '{"DataRODetail": ' . json_encode($DataRODetail) . '}';
            else
                 echo '{"error":{"text":"No data"}}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiROHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $cart_id = $data->cart_id;
    $WHSID = $data->WHSID;
    try {
        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from tblTrnROHeader ORDER By CreatedDate DESC";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataROHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataROHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTransaksiROHdrFilter() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from tblTrnROHeader where Status != 1 TransDate>=:dari and TransDate<=:sampai order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataROHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataROHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getRODtl() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody()); 
    $TransID = $data->TransID;
    try {
        if (1) {
            $db = getDB();

            $sql = "SELECT * FROM vwRO WHERE TransID=:TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"DataRoDtl": ' . json_encode($cartData) . '}';
            else
                echo '{"DataRoDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function deleteRODtl() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody()); 
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    try {
        if (1) {
            $db = getDB();
            $sql0 = "DELETE FROM tblTrnRODetail WHERE TransID=:TransID AND ItemID=:ItemID";
            $stmt0 = $db->prepare($sql0);
            $stmt0->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt0->bindParam("ItemID", $ItemID, PDO::PARAM_STR);
            $stmt0->execute();

            $sql = "SELECT * FROM vwRO WHERE TransID=:TransID2";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID2", $TransID, PDO::PARAM_STR);
            $stmt->execute();
            $cartData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"DataRoDtl": ' . json_encode($cartData) . '}';
            else
                echo '{"DataRoDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function insertBTB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    $Qnty = $data->Qnty;
    $UserID = $data->UserID;
    $WHSID = $data->WHSID;
    $TransDate = $data->TransDate;
    $Flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSOfflineSave @TransID=:TransID, @ItemID=:ItemID, @Qnty=:Qnty, @UserID=:UserID, @WHSID=:WHSID, @TransDate=:TransDate, @Flag=:Flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('TransDate', $TransDate, PDO::PARAM_STR);
            $stmt->bindParam('Flag', $Flag, PDO::PARAM_STR);
            $stmt->execute();
            echo '{"suksesDetail": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiBPG() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwStockAvailable where WHSID IN (15, 16)  and QntyAvailable > 0";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"bpgData": ' . json_encode($feedData) . '}';
            else
                echo '{"bpgData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiKas() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from pos_tbl_transaksi_kas where type_kas IN ('PK')  order by tanggal desc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"kasData": ' . json_encode($feedData) . '}';
            else
                echo '{"kasData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function filterTransaksiKas() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select *,  (select SUM(total_kas) from pos_tbl_transaksi_kas where type_kas = 'KT' and tanggal BETWEEN :dariCI and :sampaiCI) as CI, (select SUM(total_kas) from pos_tbl_transaksi_kas where type_kas = 'KK' and tanggal BETWEEN :dariCO and :sampaiCO) as CO, (select SUM(total_kas) from pos_tbl_transaksi_kas where type_kas = 'KT' and tanggal BETWEEN :dariSaldoCI and :sampaiSaldoCI) - (select SUM(total_kas) from pos_tbl_transaksi_kas where type_kas = 'KK' and tanggal BETWEEN :dariSaldoCO and :sampaiSaldoCO) as Saldo from pos_tbl_transaksi_kas where type_kas IN ('KT', 'KK') and tanggal BETWEEN :dari and :sampai order by tanggal desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('dariCI', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampaiCI', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('dariCO', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampaiCO', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('dariSaldoCI', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampaiSaldoCI', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('dariSaldoCO', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampaiSaldoCO', $sampai, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"filterData": ' . json_encode($feedData) . '}';
            else
                echo '{"filterData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTransaksiBPGHdr() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select ItemID, ItemName from vwStockAvailable where WHSID in (15,16) and QntyAvailable > 0 group by ItemID, ItemName";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"prodData": ' . json_encode($feedData) . '}';
            else
                echo '{"prodData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTransaksiPenjualanSyncron() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiPenjualanHdr() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr where TransDate = CONVERT(char(10), GetDate(),126) order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiPenjualanHdrFilter() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr where CreatedDate>=:dari and CreatedDate<=:sampai order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiRefundDtl() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where StatusCancel = '1'  order by CreatedDate desc";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiRefundDtlFilter() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where StatusCancel = '1' and CreatedDate>=:dari and CreatedDate<:sampai order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiVoid() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where Status = '3'  order by CreatedDate desc";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiVoidFilter() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where Status = '3' and CreatedDate>=:dari and CreatedDate<:sampai order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiPromo() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where Discount != 0  order by CreatedDate desc";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getTransaksiPromoFilter() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where Discount != 0 and CreatedDate>=:dari and CreatedDate<:sampai order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiPenjualanDtlV1() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan WHERE TransDate >=:dari AND TransDate <=:sampai and WHSID=:WHSID  order by TransDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiPenjualanDtl() {
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan  order by TransDate desc";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function postVoid(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $UserID = $data->UserID;
    try{
        if ($TransID) {
            $db = getDB();
            $sql = "update tblTrnPenjualanHdr set Status = 3, Pembelian=0, SubTotal=0, Kembali=Dibayar, Dibayar=0,DPPPajakRest=0,PPDAmount=0, DPPPPN=0, Discount=0, DiscountAbbr=0, Remark='Telah dilakukan void', LastUpdatedBy=:UserID, LastUpdatedDate=getdate() where TransID =:TransID";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->bindParam("UserID", $UserID, PDO::PARAM_STR);
            $stmt->execute();
            $db = null;

            $db1 = getDB();
            $sql1 = "update tblTrnPOSPayment set Status = 3, GrandTotal=0 where TransID =:TransID1";
            $stmt1 = $db1->prepare($sql1);
            $stmt1->bindParam("TransID1", $TransID, PDO::PARAM_STR);
            $stmt1->execute();
            $db1 = null;
            echo '{"success":{"text":"Void telah berhasil"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function postRefund(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;
    $ItemID = $data->ItemID;
    $UserID = $data->UserID;
    $UnitPrice = $data->UnitPrice;
    try{
        if ($TransID) {
            $db = getDB();
            $sql = "EXEC spPOSRefundSave @TransID=:TransID, @ItemID=:ItemID, @UserID=:UserID, @UnitPrice=:UnitPrice";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("TransID", $TransID, PDO::PARAM_STR);
            $stmt->bindParam("ItemID", $ItemID, PDO::PARAM_STR);
            $stmt->bindParam("UserID", $UserID, PDO::PARAM_STR);
            $stmt->bindParam("UnitPrice", $UnitPrice, PDO::PARAM_STR);
            $stmt->execute();
            $db = null;
            echo '{"success":{"text":"Void telah berhasil"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertCartBPG() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $type_cart = $data->type_cart;
    $TransID = $data->TransID;
    $WHSIDFrom = $data->WHSIDFrom;
    $WHSIDTo = $data->WHSIDTo;
    $BTBID = $data->BTBID;
    $BPGRequestID = $data->BPGRequestID;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $ItemID = $data->ItemID;
    $ProductionDate = $data->ProductionDate;
    $Qnty = $data->Qnty;
    $RemarkDtl = $data->RemarkDtl;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSCartBPG @type_cart=:type_cart, @TransID=:TransID, @WHSIDFrom=:WHSIDFrom, @WHSIDTo=:WHSIDTo, @BTBID=:BTBID, @BPGRequestID=:BPGRequestID, @Remark=:Remark, @UserID=:UserID, @ItemID=:ItemID, @ProductionDate=:ProductionDate, @Qnty=:Qnty, @RemarkDtl=:RemarkDtl, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('WHSIDFrom', $WHSIDFrom, PDO::PARAM_STR);
            $stmt->bindParam('WHSIDTo', $WHSIDTo, PDO::PARAM_STR);
            $stmt->bindParam('BTBID', $BTBID, PDO::PARAM_STR);
            $stmt->bindParam('BPGRequestID', $BPGRequestID, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('ProductionDate', $ProductionDate, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('RemarkDtl', $RemarkDtl, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();


            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and type_cart=:type_cart and check_out = 0 ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $UserID, PDO::PARAM_STR);
            $stmt1->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            
            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertCartBPB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $type_cart = $data->type_cart;
    $TransID = $data->TransID;
    $DeptID = $data->DeptID;
    $BTBID = $data->BTBID;
    $BPGRequestID = $data->BPGRequestID;
    $Remark = $data->catatan;
    //Untuk sementara
    //$UserID = $data->UserID;
    //$WHSID = $data->WHSID;
    $UserID = 'Herry';
    $WHSID = '15';
    $ItemID = $data->ItemID;
    $ProductionDate = $data->ProductionDate;
    $Qnty = $data->quantity;
    $RemarkDtl = $data->RemarkDtl;
    $flag = 0;

    try {
            $db = getDB();
            $sql = "Exec spPOSCartBPB @type_cart=:type_cart, @TransID=:TransID, @WHSID=:WHSID, @DeptID=:DeptID, @BTBID=:BTBID, @BPGRequestID=:BPGRequestID, @Remark=:Remark, @UserID=:UserID, @ItemID=:ItemID, @ProductionDate=:ProductionDate, @Qnty=:Qnty, @RemarkDtl=:RemarkDtl, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('DeptID', $DeptID, PDO::PARAM_STR);
            $stmt->bindParam('BTBID', $BTBID, PDO::PARAM_STR);
            $stmt->bindParam('BPGRequestID', $BPGRequestID, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('ProductionDate', $ProductionDate, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('RemarkDtl', $RemarkDtl, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();


            $sql1 = "SELECT * FROM vwPOSTrnCart WHERE username=:username and type_cart=:type_cart and check_out = 0 ORDER BY cart_item_id";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("username", $UserID, PDO::PARAM_STR);
            $stmt1->bindParam('type_cart', $type_cart, PDO::PARAM_STR);
            
            $stmt1->execute();
            $cartData = $stmt1->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($cartData)
                echo '{"cartData": ' . json_encode($cartData) . '}';
            else
                echo '{"cartData": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getTransaksiPenjualanHdrV1() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $cart_id = $data->cart_id;
    $WHSID = $data->WHSID;
    try {
        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr where TransDate = CONVERT(char(10), GetDate(),126) and WHSID=:WHSID order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getTransaksiPenjualanHdrFilterV1() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $WHSID = $data->WHSID;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr where TransDate>=:dari and TransDate<=:sampai AND WHSID=:WHSID order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('dari', $dari, PDO::PARAM_STR);
            $stmt->bindParam('sampai', $sampai, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function insertBPG() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $ItemID = $data->ItemID;
    $Qnty = $data->Qnty;
    $WHSIDFrom = $data->WHSIDFrom;
    $WHSIDTo = $data->WHSIDTo;
    $ProductionDate = $data->ProductionDate;
    $BPGRequestID = $data->BPGRequestID;
    $BTBID = $data->BTBID;
    $StatusBPG = $data->StatusBPG;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $RemarkDtl = $data->RemarkDtl;
    $flag = '0';

    try {
            $db = getDB();
            $sql = "Exec spPOSBPGSave @ItemID=:ItemID,@Qnty=:Qnty, @WHSIDFrom=:WHSIDFrom, @WHSIDTo=:WHSIDTo, @ProductionDate=:ProductionDate, @BPGRequestID=:BPGRequestID, @BTBID=:BTBID, @StatusBPG=:StatusBPG, @Remark=:Remark, @UserID=:UserID, @RemarkDtl=:RemarkDtl, @flag=:flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('ItemID', $ItemID, PDO::PARAM_STR);
            $stmt->bindParam('Qnty', $Qnty, PDO::PARAM_STR);
            $stmt->bindParam('WHSIDFrom', $WHSIDFrom, PDO::PARAM_STR);
            $stmt->bindParam('WHSIDTo', $WHSIDTo, PDO::PARAM_STR);            
        $stmt->bindParam('ProductionDate', $ProductionDate, PDO::PARAM_STR);
            $stmt->bindParam('BPGRequestID', $BPGRequestID, PDO::PARAM_STR);
            $stmt->bindParam('BTBID', $BTBID, PDO::PARAM_STR);
            $stmt->bindParam('StatusBPG', $StatusBPG, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('RemarkDtl', $RemarkDtl, PDO::PARAM_STR);
            $stmt->bindParam('flag', $flag, PDO::PARAM_INT);
            $stmt->execute();
    
            $db = null;

            echo '{"SuksesDtl": "BERHASIL"}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function insertBPB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $cart_id = $data->cart_id;
    $WHSID = $data->WHSID;
    $DeptID = $data->DeptID;
    $BTBID = $data->BTBID;
    $StatusBPB = $data->StatusBPB;
    $BPGRequestID = $data->BPGRequestID;
    $Remark = $data->Remark;
    $UserID = $data->UserID;
    $RemarkDtl = $data->RemarkDtl;
    $Flag = '0';

    try {
            $db = getDB();
            $sql = "Exec spPOSBPBSave @cart_id=:cart_id, @WHSID=:WHSID, @DeptID=:DeptID, @BTBID=:BTBID, @StatusBPB=:StatusBPB, @BPGRequestID=:BPGRequestID, @Remark=:Remark, @UserID=:UserID, @RemarkDtl=:RemarkDtl, @Flag=:Flag";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('cart_id', $cart_id, PDO::PARAM_STR);
            $stmt->bindParam('WHSID', $WHSID, PDO::PARAM_STR);
            $stmt->bindParam('DeptID', $DeptID, PDO::PARAM_STR);
            $stmt->bindParam('BTBID', $BTBID, PDO::PARAM_STR);
            $stmt->bindParam('StatusBPB', $StatusBPB, PDO::PARAM_STR);
            $stmt->bindParam('BPGRequestID', $BPGRequestID, PDO::PARAM_STR);
            $stmt->bindParam('Remark', $Remark, PDO::PARAM_STR);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('RemarkDtl', $RemarkDtl, PDO::PARAM_STR);
            $stmt->bindParam('Flag', $Flag, PDO::PARAM_INT);
            $stmt->execute();
            echo '{"SUKSES": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function feed() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $token = $data->token;
    $lastCreated = $data->lastCreated;
    $systemToken = apiToken($user_id);

    try {

        if ($systemToken == $token) {
            $feedData = '';
            $db = getDB();
            if ($lastCreated) {
                $sql = "SELECT * FROM feed WHERE user_id_fk=:user_id AND created < :lastCreated ORDER BY feed_id DESC LIMIT 5";
                $stmt = $db->prepare($sql);
                $stmt->bindParam("user_id", $user_id, PDO::PARAM_INT);
                $stmt->bindParam("lastCreated", $lastCreated, PDO::PARAM_STR);
            } else {
                $sql = "SELECT * FROM feed WHERE user_id_fk=:user_id ORDER BY feed_id DESC LIMIT 5";
                $stmt = $db->prepare($sql);
                $stmt->bindParam("user_id", $user_id, PDO::PARAM_INT);
            }
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"feedData": ' . json_encode($feedData) . '}';
            else
                echo '{"feedData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function verifikasiPIN() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $UserID= $data->UserID;
    $pin = $data->pin;
    try {
            $feedData = '';
            $db = getDB();

            $sql = "select * from tblMstUser where UserName=:UserID and PIN=:pin ";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('UserID', $UserID, PDO::PARAM_STR);
            $stmt->bindParam('pin', $pin, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataUser": ' . json_encode($feedData) . '}';
            else
                echo '{"DataUser": ""}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function feedUpdate() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $token = $data->token;
    $feed = $data->feed;

    $systemToken = apiToken($user_id);

    try {

        if ($systemToken == $token) {


            $feedData = '';
            $db = getDB();
            $sql = "INSERT INTO feed ( feed, created, user_id_fk) VALUES (:feed,:created,:user_id)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("feed", $feed, PDO::PARAM_STR);
            $stmt->bindParam("user_id", $user_id, PDO::PARAM_INT);
            $created = time();
            $stmt->bindParam("created", $created, PDO::PARAM_INT);
            $stmt->execute();



            $sql1 = "SELECT * FROM feed WHERE user_id_fk=:user_id ORDER BY feed_id DESC LIMIT 1";
            $stmt1 = $db->prepare($sql1);
            $stmt1->bindParam("user_id", $user_id, PDO::PARAM_INT);
            $stmt1->execute();
            $feedData = $stmt1->fetch(PDO::FETCH_OBJ);


            $db = null;
            echo '{"feedData": ' . json_encode($feedData) . '}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function feedDelete() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $token = $data->token;
    $feed_id = $data->feed_id;

    $systemToken = apiToken($user_id);

    try {

        if ($systemToken == $token) {
            $feedData = '';
            $db = getDB();
            $sql = "Delete FROM feed WHERE user_id_fk=:user_id AND feed_id=:feed_id";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("user_id", $user_id, PDO::PARAM_INT);
            $stmt->bindParam("feed_id", $feed_id, PDO::PARAM_INT);
            $stmt->execute();


            $db = null;
            echo '{"success":{"text":"Feed deleted"}}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

$app->post('/userImage', 'userImage'); /* User Details */

function userImage() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $token = $data->token;
    $imageB64 = $data->imageB64;
    $systemToken = apiToken($user_id);
    try {
        if (1) {
            $db = getDB();
            $sql = "INSERT INTO imagesData(b64,user_id_fk) VALUES(:b64,:user_id)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("user_id", $user_id, PDO::PARAM_INT);
            $stmt->bindParam("b64", $imageB64, PDO::PARAM_STR);
            $stmt->execute();
            $db = null;
            echo '{"success":{"status":"uploaded"}}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

$app->post('/getImages', 'getImages');

function getImages() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $token = $data->token;

    $systemToken = apiToken($user_id);
    try {
        if (1) {
            $db = getDB();
            $sql = "SELECT b64 FROM imagesData";
            $stmt = $db->prepare($sql);

            $stmt->execute();
            $imageData = $stmt->fetchAll(PDO::FETCH_OBJ);
            $db = null;
            echo '{"imageData": ' . json_encode($imageData) . '}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

//////////// MONITORING POS
function getRptSaldo(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $WHSID = $data->WHSID;
    $tanggal = $data->tanggal;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from tblTransaksiSaldoHdr where MONTH(tanggal)=MONTH(:tanggal) and OutletId =:WHSID order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);
            $stmt->bindParam("tanggal", $tanggal, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataSaldo": ' . json_encode($feedData) . '}';
            else
                echo '{"DataSaldo": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getRptPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualan where TransDate BETWEEN :dari and :sampai order by TransDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}


function getRptStockPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $Itemname = '%'.$data->Itemname.'%';
    try {

        if (1) {
            $customerData = '';
            $db = getDB();
            $sql = "select  * from vwPOSStockPenjualan WHERE ItemName LIKE :Itemname and WHSID IN (15,16) order by SubCategoryName, ItemName asc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('Itemname', $Itemname, PDO::PARAM_STR);
            $stmt->execute();
            $customerData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($customerData)
                echo '{"productData": ' . json_encode($customerData) . '}';
            else
                echo '{"productData": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getRptPaymentPenjualan() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwPenjualanHdr where MONTH(TransDate) BETWEEN MONTH(:dari) and MONTH(:sampai) AND YEAR(TransDate) BETWEEN  YEAR(:dari1) and YEAR(:sampai1)  order by CreatedDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("dari1", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai1", $sampai, PDO::PARAM_STR);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanHdr": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getRptBPG() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $jenis = '%'.$data->jenis.'%';
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwTransferWHS where WHSIDFrom = 15 and TransferRemark like :jenis and MONTH(TransDate) BETWEEN MONTH(:dari) and MONTH(:sampai) and YEAR(TransDate) BETWEEN YEAR(:dari1) and YEAR(:sampai1) order by TransDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("dari1", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai1", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("jenis", $jenis, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getRptBPBHdr() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $StatusBPB = $data->StatusBPB;
    $WHSID = $data->WHSID;
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from tblTrnBPBHdr where WHSID =:WHSID and StatusBPB=:StatusBPB order by TransDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("StatusBPB", $StatusBPB, PDO::PARAM_STR);
            $stmt->bindParam("WHSID", $WHSID, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataBPBHdr": ' . json_encode($feedData) . '}';
            else
                echo '{"dataKosong": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function getRptBPB() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $dari = $data->dari;
    $sampai = $data->sampai;
    $jenis = '%'.$data->jenis.'%';
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select * from vwBPB where WHSID = 15 and Remark like :jenis and MONTH(TransDate) BETWEEN MONTH(:dari) and MONTH(:sampai) and YEAR(TransDate) BETWEEN YEAR(:dari1) and YEAR(:sampai1) order by TransDate desc";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("dari", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("dari1", $dari, PDO::PARAM_STR);
            $stmt->bindParam("sampai1", $sampai, PDO::PARAM_STR);
            $stmt->bindParam("jenis", $jenis, PDO::PARAM_STR);

            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"DataPenjualanDtl": ' . json_encode($feedData) . '}';
            else
                echo '{"DataPenjualanDtl": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getEmailSubcribe(){
    try {

        if (1) {
            $feedData = '';
            $db = getDB();

            $sql = "select email from tblMstSubcribe where apps = 'kara_island' and subcribe = '1'";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $DataSubcribe = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataSubcribe)
                echo '{"DataSubcribe": ' . json_encode($DataSubcribe) . '}';
            else
                echo '{"DataSubcribe": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartItem() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select CategoryNamePOS, SUM(Qnty) as Qnty from vwPenjualan where Status <> 3 AND YEAR(TransDate) =  datepart(yyyy,getdate()) group by CategoryNamePOS order by SUM(Qnty) desc";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartSales(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select MONTH(TransDate) as bulan,  SUM(GrandTotal) as total from tblTrnPOSPayment where Status <> 3 AND Year(TransDate) = datepart(yyyy,getdate()) group by MONTH(TransDate)";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartPayment(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select Payment, SUM(GrandTotal) total from tblTrnPOSPayment where Status <> 3 AND Year(TransDate) = datepart(yyyy,getdate()) group by Payment";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartCashier(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select CreatedBy, SUM(GrandTotal) total from tblTrnPOSPayment where Status <> 3 AND Year(TransDate) = datepart(yyyy,getdate()) group by CreatedBy";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartDiscount(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select B.Title, CONVERT(int,SUM(a.Discount),0) total from vwPenjualanHdr as a LEFT JOIN  tblMstPromo as B ON a.PromoCode = B.PromoCode where Status <> 3 AND Year(a.TransDate) = datepart(yyyy,getdate()) and a.PromoCode != '' group by B.Title";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getChartDiscountFilter(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $tanggal_awal = $data->tanggal_awal;
    $tanggal_akhir = $data->tanggal_akhir;
    $whs_id = $data->whs_id;
    try {

        if (1) {
            $f = '';
            $db = getDB();

            $sql = "select B.Title, CONVERT(int,SUM(a.Discount),0) total from vwPenjualanHdr as a LEFT JOIN  tblMstPromo as B ON a.PromoCode = B.PromoCode where Status <> 3 AND a.TransDate >=:tanggal_awal AND a.TransDate <=:tanggal_akhir and WHSID=:whs_id and a.PromoCode != '' group by B.Title";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("tanggal_awal", $tanggal_awal, PDO::PARAM_STR);
            $stmt->bindParam("tanggal_akhir", $tanggal_akhir, PDO::PARAM_STR);
            $stmt->bindParam("whs_id", $whs_id, PDO::PARAM_STR);
            $stmt->execute();
            $f = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($f)
                echo json_encode($f);
            else
                echo '{"labels": ""}';
        } else {
            echo '{"error":{"text":"No access"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}